<?php
/*****************************************************************************/
/* Memberlist.php                                                            */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$memberlistphpver = 'YaBB SE 1.5.1';

if (!defined('YaBBSE'))
 	die('Hacking attempt...');

// initialize variables
global $txt, $cgi, $color, $img, $TopAmmount, $action, $scripturl, $MOST_POSTS, $TableHeader, $TableFooter, $username, $db_prefix, $NUM_MEMBERS, $imagesdir;

$Sort = $page = $LetterLinks = $TableHeader = '';

if ($username == "Guest")
	fatal_error($txt[223]);

if ($action == 'mlall')
	$Sort = "$txt[303] | ";
else 
	$Sort = "<a href=\"$cgi;action=mlall\"><font size=\"2\" class=\"text1\" color=\"$color[titletext]\">$txt[303]</font></a> | ";

if ($action == 'mlmemgrp')
	$Sort .= "$txt[yse288] | ";
else 
	$Sort .= "<a href=\"$cgi;action=mlmemgrp\"><font size=\"2\" class=\"text1\" color=\"$color[titletext]\">$txt[yse288]</font></a> | ";
	
if ($action == "mlletter")
	$Sort .= "$txt[304] | ";
else
	$Sort .= "<a href=\"$cgi;action=mlletter\"><font size=\"2\" class=\"text1\" color=\"$color[titletext]\">$txt[304]</font></a> | ";

if ($action == "mltop")
	$Sort .= "$txt[305] $txt[411] $TopAmmount $txt[306]";
else
	$Sort .= "<a href=\"$cgi;action=mltop\"><font size=\"2\" class=\"text1\" color=\"$color[titletext]\">$txt[305] $txt[411] $TopAmmount $txt[306]</font></a>";

if ($action == "mlletter")
{
	for ($i = 48; $i < 58; $i++)
		$LetterLinks .= "<a href=\"$scripturl?action=mlletter;letter=".chr($i)."\">".strtoupper(chr($i))."</a> ";

	for ($i = 97; $i < 123; $i++)
		$LetterLinks .= "<a href=\"$scripturl?action=mlletter;letter=".chr($i)."\">".strtoupper(chr($i))."</a> ";
}

$TableHeader .= '
	<table border="0" width="100%" cellspacing="1" cellpadding="4" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
		<tr>
			<td class="titlebg" bgcolor="' . $color['titlebg'] . '" colspan="11">
				<b><font size="2" class="text1" color="' . $color['titletext'] . '">' . $Sort . '</font></b>
			</td>
		</tr>';

if ($LetterLinks != '')
	$TableHeader .= '
		<tr>
			<td class="catbg" bgcolor="'. $color['catbg'] . '" colspan="11">
				<b><font size="2">' . $LetterLinks . '</font></b>
			</td>
		</tr>';
$imgEmail = "<img src=\"$imagesdir/email_sm.gif\" alt=\"$txt[307]\" title=\"$txt[307]\" border=\"0\" />";
$imgWebsite = "<img src=\"$imagesdir/www.gif\" alt=\"$txt[96]\" title=\"$txt[96]\" border=\"0\" />";
$imgICQ = "<img src=\"$imagesdir/icq.gif\" alt=\"$txt[513]\" title=\"$txt[513]\" border=\"0\" />";
$imgAIM = "<img src=\"$imagesdir/aim.gif\" alt=\"$txt[603]\" title=\"$txt[603]\" border=\"0\" />";
$imgYIM = "<img src=\"$imagesdir/yim.gif\" alt=\"$txt[604]\" title=\"$txt[604]\" border=\"0\" />";
$imgMSN = "<img src=\"$imagesdir/msntalk.gif\" alt=\"MSN\" title=\"MSN\" border=\"0\" />";
$TableHeader .= '
		<tr>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="20"><b><font size="2">' . $txt['online8'] . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '"><b><font size="2">' . $txt[35] . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="25" align="center"><b><font size="2">' . $imgEmail . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="25" align="center"><b><font size="2">' . $imgWebsite . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="25" align="center"><b><font size="2">' . $imgICQ . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="25" align="center"><b><font size="2">' . $imgAIM . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="25" align="center"><b><font size="2">' . $imgYIM . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" width="25" align="center"><b><font size="2">' . $imgMSN . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '"><b><font size="2">' . $txt[87] . '</font></b></td>
			<td class="catbg" bgcolor="' . $color['catbg'] . '" colspan="2"><b><font size="2">' . $txt[21] . '</font></b></td>
		</tr>';

$TableFooter = '
	</table>';

$result = mysql_query ("SELECT COUNT(*) as memcount FROM {$db_prefix}members") or database_error(__FILE__, __LINE__);
$row = mysql_fetch_row($result);
$NUM_MEMBERS = $row[0];

$result = mysql_query("SELECT MAX(posts) FROM {$db_prefix}members") or database_error(__FILE__, __LINE__);
$row = mysql_fetch_row($result);
$MOST_POSTS = ($row[0] != 0)?$row[0]:1;
if ($MOST_POSTS == 0)
	$MOST_POSTS=1;

function MLAll ()
{
	global $user, $txt, $start, $MembersPerPage, $settings, $allow_hide_email, $color, $TableHeader, $MOST_POSTS;
	global $imagesdir, $cgi, $TableFooter, $db_prefix;
	global $NUM_MEMBERS, $yytitle;

	if ($user == 'Guest')
		fatal_error($txt[223]);

	# Get the number of members
	$memcount = $NUM_MEMBERS;
	
	if ($start == '')
		$start = 0;

	$numbegin = $start + 1;
	$numend = ($start + $MembersPerPage);
	if ($numend > $memcount)
		$numend = $memcount;

	$yytitle = "$txt[308] $numbegin $txt[311] $numend";
	template_header();

	echo '
		<table border="0" cellspacing="0" cellpadding="3" align="center" width="100%">
			<tr>
				<td bgcolor="' . $color['titlebg'] . '" align="center" class="titlebg">
					<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[308] . ' ' . $numbegin . ' ' . $txt[311] . ' ' . $numend . ' (' . $txt[309] . ' ' . $memcount . ' ' . $txt[310] . ')</b></font>
				</td>
			</tr>
		</table>';

	echo $TableHeader;

	$query = "SELECT memberName,realName,websiteTitle,websiteUrl,posts,memberGroup,ICQ,AIM,YIM,MSN,emailAddress,hideEmail,ID_MEMBER FROM {$db_prefix}members WHERE 1 LIMIT $start,$MembersPerPage";
	printMemberListRows($query);

	echo $TableFooter;

	echo '
		<table border="0" width="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td>
					<font size="2">
						<b>' . $txt[139] . ':</b>';
	$c = 0;
	while (($c*$MembersPerPage) < $NUM_MEMBERS)
	{
		$viewc = $c + 1;
		$strt = $c * $MembersPerPage;
		if ($start == $strt)
			echo " $viewc";
		else
			echo " <a href=\"$cgi;action=mlall;start=$strt\">$viewc</a>";
		$c++;
	}
	echo '
					</font>
				</td>
			</tr>
		</table>';

	footer();
	obExit();
}

function MLByLetter ()
{
	global $username, $txt, $TableHeader, $TableFooter, $MOST_POSTS, $NUM_MEMBERS, $letter, $imagesdir, $cgi, $settings;
	global $color, $yytitle, $allow_hide_email, $db_prefix;

	if ($username == 'Guest')
		fatal_error("$txt[223]");

	$yytitle = $txt[312];
	template_header();
	echo $TableHeader;

	if (isset($letter))
		$query = "SELECT * FROM {$db_prefix}members WHERE (SUBSTRING(realName,1,1)='$letter') ORDER BY realName";
	else
		$query = "
			SELECT *
			FROM {$db_prefix}members
			WHERE ((LOWER(SUBSTRING(realName,1,1)) NOT BETWEEN 'a' AND 'z') AND (SUBSTRING(realName,1,1) NOT BETWEEN '0' AND '9'))
			ORDER BY realName";
	printMemberListRows($query);
	$request = mysql_query($query) or database_error(__FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		echo '
			<tr>
				<td colspan="11" class="windowbg" bgcolor="' . $color['windowbg'] . '">
					' . $txt[170] . '
				</td>
			</tr>';

	echo $TableFooter;

	footer();
	obExit();
}

function MLTop ()
{
	global $user, $txt, $start, $MembersPerPage, $settings, $allow_hide_email, $TopAmmount, $color;
	global $TableHeader, $MOST_POSTS, $imagesdir, $cgi, $db_prefix;
	global $NUM_MEMBERS, $TableFooter, $yytitle;

 	if ($user == "Guest")
		fatal_error($txt[223]);

	$yytitle = "$txt[313] $TopAmmount $txt[314]";
	template_header();
	echo $TableHeader;

	$query = "SELECT * FROM {$db_prefix}members WHERE 1 ORDER BY posts DESC LIMIT $TopAmmount";
	printMemberListRows($query);

	echo $TableFooter;

	footer();
	obExit();
}

function MLMemgrp ()
{
	global $user, $txt, $start, $MembersPerPage, $settings, $allow_hide_email, $color, $TableHeader, $MOST_POSTS;
	global $imagesdir, $cgi, $TableFooter, $db_prefix;
	global $NUM_MEMBERS, $yytitle;

	if ($MOST_POSTS == 0)
		$MOST_POSTS = 1;

	if ($user == 'Guest')
		fatal_error($txt[223]);

	// Get the number of members
	$result = mysql_query ("SELECT COUNT(*) FROM {$db_prefix}members WHERE memberGroup != ''") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_row($result);
	$memcount = $row[0];
	
	if ($start == '')
		$start = 0;

	$numbegin = $start + 1;
	$numend = ($start + $MembersPerPage);
	if ($numend > $memcount)
		$numend = $memcount;

	$yytitle = "$txt[308] $numbegin $txt[311] $numend";
	template_header();

	echo '
		<table border="0" cellspacing="0" cellpadding="3" align="center" width="100%">
			<tr>
				<td bgcolor="' . $color['titlebg'] . '" align="center" class="titlebg">
					<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[308] . ' ' . $numbegin . ' ' . $txt[311] . ' ' . $numend . ' (' . $txt[309] . ' ' . $NUM_MEMBERS . ' ' . $txt[310] . ')</b></font>
				</td>
			</tr>
		</table>';

	echo $TableHeader;

	$membergroup = $row['memberGroup'];
	$mg_request = mysql_query("SELECT membergroup FROM {$db_prefix}membergroups ORDER BY ID_GROUP") or database_error(__FILE__, __LINE__); //query membergroups descriptions
	$membergroups = array();
	while ($mg_row = mysql_fetch_row($mg_request)) //retrieve all membergroups descriptions
		$membergroups[] = $mg_row[0];

	$query = "
		SELECT memberName,realName,websiteTitle,websiteUrl,posts,IF(memberGroup='Administrator','$membergroups[0]',IF(memberGroup='Global Moderator','$membergroups[7]',memberGroup)) AS theMemberGroup,ICQ,YIM,AIM,MSN,emailAddress,hideEmail,IF(memberGroup<>'',1,0) AS belongsToMembergroup, ID_MEMBER
		FROM {$db_prefix}members
		WHERE 1
		ORDER BY belongsToMembergroup DESC,theMemberGroup
		LIMIT $start,$MembersPerPage";
	printMemberListRows($query, true);

	echo $TableFooter;

	echo '
		<table border="0" width="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td>
					<font size="2">
						<b>' . $txt[139] . ':</b>';
	$c = 0;
	while (($c*$MembersPerPage) < $NUM_MEMBERS)
	{
		$viewc = $c + 1;
		$strt = $c * $MembersPerPage;
		if ($start == $strt)
			echo " $viewc";
		else
			echo " <a href=\"$cgi;action=mlmemgrp;start=$strt\">$viewc</a>";
		$c++;
	}
	echo '
					</font>
				</td>
			</tr>
		</table>';

	footer();
	obExit();
}

function printMemberListRows($query, $isByMG = false)
{
	global $color, $cgi, $img, $txt, $imagesdir, $settings, $MOST_POSTS, $db_prefix, $allow_hide_email;

	$request = mysql_query($query) or database_error(__FILE__, __LINE__);
	while ($row = mysql_fetch_array($request))
	{
		$name = $row['memberName'];
		if (OnlineStatus($row['ID_MEMBER']) > 0)
			$online = $txt['online6'];
		else
			$online = $txt['online7'];

		$Bar = '&nbsp;';

		$barchart = round(($row['posts'] / $MOST_POSTS) * 100);
		if ($barchart <= 0)
			$barchart = 1;
		$Bar = "<img src=\"$imagesdir/bar.gif\" width=\"$barchart\" height=\"15\" border=\"0\" alt=\"\" />";

		if (!empty($row['ICQ']))
			$row['ICQ'] = "<a href=\"$cgi;action=icqpager;UIN=$row[ICQ]\" target=\"_blank\"><img src=\" http://web.icq.com/whitepages/online?icq=$row[ICQ]&amp;img=5\" alt=\"$row[ICQ]\" border=\"0\" /></a>";
		if (!empty($row['AIM']))
			$row['AIM'] = "<a href=\"aim:goim?screenname=$row[AIM]&message=Hi.+Are+you+there?\" target=\"_blank\"><img src=\"$imagesdir/aim.gif\" alt=\"$row[AIM]\" border=\"0\" /></a>";
		if (!empty($row['YIM']))
			$row['YIM'] = "<a href=\"http://opi.yahoo.com/online?u=$row[YIM]&m=g&t=0\" target=\"_blank\"><img src=\"http://opi.yahoo.com/online?u=$row[YIM]&m=g&t=0\" alt=\"$row[YIM]\" border=\"0\" /></a>";
		if (!empty($row['MSN']))
			$row['MSN'] = "<a href=\"http://members.msn.com/$row[MSN]\" target=\"_blank\"><img src=\"$imagesdir/msntalk.gif\" alt=\"$row[MSN]\" border=\"0\" /></a>";

		$websiteimg = (isset($row['websiteTitle']) ? "<img src=\"$imagesdir/www.gif\" alt=\"$row[websiteTitle]\" title=\"$row[websiteTitle]\" border=\"0\" />" : "<img src=\"$imagesdir/www.gif\" alt=\"$txt[96]\" border=\"0\" />");
		$row['websiteUrl'] = ($row['websiteUrl'] != '' ? "<a href=\"$row[websiteUrl]\" target=\"_blank\">$websiteimg</a>" : '');
		$row['emailAddress'] = (($row['hideEmail'] && $settings[7] != "Administrator" && $allow_hide_email) ? "" : "<a href=\"mailto:$row[emailAddress]\"><img src=\"$imagesdir/email_sm.gif\" alt=\"$txt[69]\" title=\"$txt[69] $row[realName]\" border=\"0\" /></a>");

		if ($isByMG)
			$membergroup = (isset($row['theMemberGroup']) ? $row['theMemberGroup'] : '');
		else
		{
			$row['memberGroup'] = (isset($row['memberGroup']) ? $row['memberGroup'] : '');
			
			//Administrator & Global Moderator position shows members description instead of membergroups description
			$membergroup = $row['memberGroup'];
			$mg_request = mysql_query("SELECT membergroup FROM {$db_prefix}membergroups ORDER BY ID_GROUP") or database_error(__FILE__, __LINE__); //query membergroups descriptions
			$membergroups = array();
			while ($mg_row = mysql_fetch_row($mg_request)) //retrieve all membergroups descriptions
				$membergroups[] = $mg_row[0];
	
			if ($membergroup == 'Administrator')
				$membergroup = $membergroups[0]; //admin description
			elseif ($membergroup == 'Global Moderator')
				$membergroup = $membergroups[7]; //Global moderator description
		}

		if ($row['posts'] > 100000)
			$row['posts'] = $txt[683];

		$euser=urlencode($row['memberName']);

		echo '
			<tr>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" align="center">
					<font size="2"><a href="' . $cgi . ';action=imsend;to=' . $row['memberName'] . '">' . $online . '</font>
				</td>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					<font size="2"><a href="' . $cgi . ';action=viewprofile;user=' . $euser . '">' . $row['realName'] . '</a></font>
				</td>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" width="25" align="center">
					<font size="2">' . $row['emailAddress'] , '</font>
				</td>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" width="25" align="center">
					<font size="2">' . $row['websiteUrl'] . '</font>&nbsp;
				</td>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" width="25" align="center">
					<font size="2">' . $row['ICQ'] . '</font>&nbsp;
				</td>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" width="25" align="center">
					<font size="2">' . $row['AIM'] . '</font>&nbsp;
				</td>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" width="25" align="center">
					<font size="2">' . $row['YIM'] . '</font>&nbsp;
				</td>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" width="25" align="center">
					<font size="2">' . $row['MSN'] . '</font>&nbsp;
				</td>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					<font size="2">' . $membergroup . '</font>&nbsp;
				</td>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '" align="center" width="15">
					<font size="2">' . $row['posts'] . '</font>&nbsp;
				</td>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					' . $Bar . '
				</td>
			</tr>';
	}
}

?>